package GUT.quals;

import java.lang.annotation.*;

import checkers.quals.SubtypeOf;
import checkers.quals.TypeQualifier;

/**
 * The Any modifier expresses no static ownership information, the referenced
 * object can have any owner.
 *
 * @author wmdietl
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.TYPE_PARAMETER, ElementType.TYPE_USE })
@TypeQualifier
@SubtypeOf({})
// @DefaultQualifierInHierarchy
/*
 * @ImplicitFor( trees={ Tree.Kind.CHAR_LITERAL, Tree.Kind.STRING_LITERAL })
 */
public @interface Any {}