package GUT.quals;

import checkers.quals.ImplicitFor;
import java.lang.annotation.*;

import checkers.quals.SubtypeOf;
import checkers.quals.TypeQualifier;
import checkers.types.AnnotatedTypeMirror.AnnotatedPrimitiveType;

import com.sun.source.tree.Tree;

/**
 * The bottom of the type hierarchy is only used internally.
 *
 * @author wmdietl
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({})
@TypeQualifier
@SubtypeOf({ Self.class, Rep.class })
@ImplicitFor(trees = { Tree.Kind.NULL_LITERAL, Tree.Kind.STRING_LITERAL },
        typeClasses = { AnnotatedPrimitiveType.class })
public @interface Bottom {}
