package GUT.quals;

import java.lang.annotation.*;

import checkers.quals.DefaultQualifierInHierarchy;
import checkers.quals.ImplicitFor;
import checkers.quals.SubtypeOf;
import checkers.quals.TypeQualifier;
import com.sun.source.tree.Tree;

/**
 * The referenced object has the same owner as the current object.
 *
 * @author wmdietl
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.TYPE_PARAMETER, ElementType.TYPE_USE })
@TypeQualifier
@DefaultQualifierInHierarchy
// TODO: why is this not happening?
@ImplicitFor(trees = { Tree.Kind.NEW_ARRAY })
@SubtypeOf({ Lost.class })
public @interface Peer {}
